Whamcloud - gitweb
LU-8952 tests: handling test specific cleanup of ost pools
[fs/lustre-release.git] / lustre / tests / sanity.sh
index c24dd3f..2216581 100755 (executable)
@@ -13,8 +13,8 @@ ALWAYS_EXCEPT="                42a  42b  42c  42d  45   68b   $SANITY_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 # with LOD/OSP landing
-# bug number for skipped tests: LU-2036 LU-8139
-ALWAYS_EXCEPT="                 76     101g    $ALWAYS_EXCEPT"
+# bug number for skipped tests: LU-2036 LU-8411
+ALWAYS_EXCEPT="                 76     407 $ALWAYS_EXCEPT"
 
 is_sles11()                                            # LU-4341
 {
@@ -2057,7 +2057,7 @@ test_27D() {
        llapi_layout_test -d$DIR/$tdir -p$POOL -o$OSTCOUNT $skip27D ||
                error "llapi_layout_test failed"
 
-       cleanup_pools || error "cleanup_pools failed"
+       destroy_test_pools || error "destroy test pools failed"
 }
 run_test 27D "validate llapi_layout API"
 
@@ -2426,10 +2426,10 @@ run_test 31p "remove of open striped directory"
 cleanup_test32_mount() {
        local rc=0
        trap 0
-       local loopdev=$(losetup -a | grep $EXT2_DEV | sed -ne 's/:.*$/p')
+       local loopdev=$(losetup -a | grep $EXT2_DEV | sed -ne 's/:.*$//p')
        $UMOUNT $DIR/$tdir/ext2-mountpoint || rc=$?
        losetup -d $loopdev || true
-       rm -rf $DIR/$tdir/ext2-mountpoint
+       rm -rf $DIR/$tdir
        return $rc
 }
 
@@ -2613,59 +2613,49 @@ test_32o() {
 run_test 32o "stat d32o/symlink->tmp/symlink->lustre-root/$tfile"
 
 test_32p() {
-    log 32p_1
+       log 32p_1
        rm -fr $DIR/d32p
-    log 32p_2
+       log 32p_2
        rm -f $DIR/$tfile
-    log 32p_3
+       log 32p_3
        touch $DIR/$tfile
-    log 32p_4
+       log 32p_4
        test_mkdir -p $DIR/d32p/tmp
-    log 32p_5
+       log 32p_5
        TMP_DIR=$DIR/d32p/tmp
-    log 32p_6
+       log 32p_6
        ln -s $DIR/$tfile $TMP_DIR/symlink12
-    log 32p_7
+       log 32p_7
        ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02
-    log 32p_8
+       log 32p_8
        cat $DIR/d32p/tmp/symlink12 || error
-    log 32p_9
+       log 32p_9
        cat $DIR/d32p/symlink02 || error
-    log 32p_10
+       log 32p_10
 }
 run_test 32p "open d32p/symlink->tmp/symlink->lustre-root/$tfile"
 
-cleanup_testdir_mount() {
-       local rc=0
-       trap 0
-       local loopdev=$(losetup -a | grep $EXT2_DEV | sed -ne 's/:.*$/p')
-       $UMOUNT $DIR/$tdir || rc=$?
-       losetup -d $loopdev || true
-       rm -rf $DIR/$tdir
-       return $rc
-}
-
 test_32q() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [ -e $DIR/$tdir ] && rm -fr $DIR/$tdir
-       trap cleanup_testdir_mount EXIT
-       test_mkdir -p $DIR/$tdir
-        touch $DIR/$tdir/under_the_mount
-       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir
-       ls $DIR/$tdir | grep "\<under_the_mount\>" && error
-       cleanup_testdir_mount
+       trap cleanup_test32_mount EXIT
+       test_mkdir -p $DIR/$tdir/ext2-mountpoint
+       touch $DIR/$tdir/ext2-mountpoint/under_the_mount
+       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir/ext2-mountpoint
+       ls $DIR/$tdir/ext2-mountpoint | grep "\<under_the_mount\>" && error
+       cleanup_test32_mount
 }
 run_test 32q "stat follows mountpoints in Lustre (should return error)"
 
 test_32r() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [ -e $DIR/$tdir ] && rm -fr $DIR/$tdir
-       trap cleanup_testdir_mount EXIT
-       test_mkdir -p $DIR/$tdir
-        touch $DIR/$tdir/under_the_mount
-       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir
-       ls $DIR/$tdir | grep -q under_the_mount && error || true
-       cleanup_testdir_mount
+       trap cleanup_test32_mount EXIT
+       test_mkdir -p $DIR/$tdir/ext2-mountpoint
+       touch $DIR/$tdir/ext2-mountpoint/under_the_mount
+       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir/ext2-mountpoint
+       ls $DIR/$tdir/ext2-mountpoint | grep -q under_the_mount && error || true
+       cleanup_test32_mount
 }
 run_test 32r "opendir follows mountpoints in Lustre (should return error)"
 
@@ -3127,7 +3117,7 @@ test_38() {
 }
 run_test 38 "open a regular file with O_DIRECTORY should return -ENOTDIR ==="
 
-test_39() {
+test_39a() { # was test_39
        touch $DIR/$tfile
        touch $DIR/${tfile}2
 #      ls -l  $DIR/$tfile $DIR/${tfile}2
@@ -3145,7 +3135,7 @@ test_39() {
                error "O_TRUNC didn't change timestamps"
        fi
 }
-run_test 39 "mtime changed on create ==========================="
+run_test 39a "mtime changed on create ==========================="
 
 test_39b() {
        test_mkdir -p -c1 $DIR/$tdir
@@ -3807,7 +3797,7 @@ test_42e() { # bug22074
 }
 run_test 42e "verify sub-RPC writes are not done synchronously"
 
-test_43() {
+test_43A() { # was test_43
        test_mkdir -p $DIR/$tdir
        cp -p /bin/ls $DIR/$tdir/$tfile
        $MULTIOP $DIR/$tdir/$tfile Ow_c &
@@ -3818,7 +3808,7 @@ test_43() {
        $DIR/$tdir/$tfile && error || true
        kill -USR1 $pid
 }
-run_test 43 "execution of file opened for write should return -ETXTBSY"
+run_test 43A "execution of file opened for write should return -ETXTBSY"
 
 test_43a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
@@ -3859,12 +3849,12 @@ test_43c() {
 }
 run_test 43c "md5sum of copy into lustre========================"
 
-test_44() {
+test_44A() { # was test_44
        [[ $OSTCOUNT -lt 2 ]] && skip_env "skipping 2-stripe test" && return
        dd if=/dev/zero of=$DIR/f1 bs=4k count=1 seek=1023
        dd if=$DIR/f1 bs=4k count=1 > /dev/null
 }
-run_test 44 "zero length read from a sparse stripe ============="
+run_test 44A "zero length read from a sparse stripe ============="
 
 test_44a() {
        local nstripe=$($LCTL lov_getconfig $DIR | grep default_stripe_count: |
@@ -5746,10 +5736,6 @@ cleanup_68() {
                rm -f $LLOOP
                unset LLOOP
        fi
-       if [ ! -z "$LLITELOOPLOAD" ]; then
-               rmmod llite_lloop
-               unset LLITELOOPLOAD
-       fi
        rm -f $DIR/f68*
 }
 
@@ -5761,74 +5747,6 @@ swap_used() {
        swapon -s | awk '($1 == "'$1'") { print $4 }'
 }
 
-# test case for lloop driver, basic function
-test_68a() {
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       [ "$UID" != 0 ] && skip_env "must run as root" && return
-       llite_lloop_enabled || \
-               { skip_env "llite_lloop module disabled" && return; }
-
-       trap cleanup_68 EXIT
-
-       if ! module_loaded llite_lloop; then
-               if load_module llite/llite_lloop; then
-                       LLITELOOPLOAD=yes
-               else
-                       skip_env "can't find module llite_lloop"
-                       return
-               fi
-       fi
-
-       LLOOP=$TMP/lloop.`date +%s`.`date +%N`
-       dd if=/dev/zero of=$DIR/f68a bs=4k count=1024
-       $LCTL blockdev_attach $DIR/f68a $LLOOP || error "attach failed"
-
-       directio rdwr $LLOOP 0 1024 4096 || error "direct write failed"
-       directio rdwr $LLOOP 0 1025 4096 && error "direct write should fail"
-
-       cleanup_68
-}
-run_test 68a "lloop driver - basic test ========================"
-
-# excercise swapping to lustre by adding a high priority swapfile entry
-# and then consuming memory until it is used.
-test_68b() {  # was test_68
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       [ "$UID" != 0 ] && skip_env "must run as root" && return
-       lctl get_param -n devices | grep -q obdfilter && \
-               skip "local OST" && return
-
-       grep -q llite_lloop /proc/modules
-       [ $? -ne 0 ] && skip "can't find module llite_lloop" && return
-
-       [ -z "`$LCTL list_nids | grep -v tcp`" ] && \
-               skip "can't reliably test swap with TCP" && return
-
-       MEMTOTAL=`meminfo MemTotal`
-       NR_BLOCKS=$((MEMTOTAL>>8))
-       [[ $NR_BLOCKS -le 2048 ]] && NR_BLOCKS=2048
-
-       LLOOP=$TMP/lloop.`date +%s`.`date +%N`
-       dd if=/dev/zero of=$DIR/f68b bs=64k seek=$NR_BLOCKS count=1
-       mkswap $DIR/f68b
-
-       $LCTL blockdev_attach $DIR/f68b $LLOOP || error "attach failed"
-
-       trap cleanup_68 EXIT
-
-       swapon -p 32767 $LLOOP || error "swapon $LLOOP failed"
-
-       echo "before: `swapon -s | grep $LLOOP`"
-       $MEMHOG $MEMTOTAL || error "error allocating $MEMTOTAL kB"
-       echo "after: `swapon -s | grep $LLOOP`"
-       SWAPUSED=`swap_used $LLOOP`
-
-       cleanup_68
-
-       [ $SWAPUSED -eq 0 ] && echo "no swap used???" || true
-}
-run_test 68b "support swapping to Lustre ========================"
-
 # bug5265, obdfilter oa2dentry return -ENOENT
 # #define OBD_FAIL_SRV_ENOENT 0x217
 test_69() {
@@ -6172,22 +6090,6 @@ test_77g() { # bug 10889
 }
 run_test 77g "checksum error on OST write, read"
 
-test_77i() { # bug 13805
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       $GSS && skip "could not run with gss" && return
-       #define OBD_FAIL_OSC_CONNECT_CKSUM       0x40b
-       lctl set_param fail_loc=0x40b
-       remount_client $MOUNT
-       lctl set_param fail_loc=0
-       for VALUE in `lctl get_param osc.*osc-[^mM]*.checksum_type`; do
-               PARAM=`echo ${VALUE[0]} | cut -d "=" -f1`
-               algo=`lctl get_param -n $PARAM | sed 's/.*\[\(.*\)\].*/\1/g'`
-               [ "$algo" = "adler" ] || error "algo set to $algo instead of adler"
-       done
-       remount_client $MOUNT
-}
-run_test 77i "client not supporting OSD_CONNECT_CKSUM"
-
 test_77j() { # bug 13805
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        $GSS && skip "could not run with gss" && return
@@ -6195,10 +6097,15 @@ test_77j() { # bug 13805
        lctl set_param fail_loc=0x40c
        remount_client $MOUNT
        lctl set_param fail_loc=0
-       sleep 2 # wait async osc connect to finish
-       for VALUE in `lctl get_param osc.*osc-[^mM]*.checksum_type`; do
-                PARAM=`echo ${VALUE[0]} | cut -d "=" -f1`
-               algo=`lctl get_param -n $PARAM | sed 's/.*\[\(.*\)\].*/\1/g'`
+       # wait async osc connect to finish and reflect updated state value
+       local i
+       for (( i=0; i < OSTCOUNT; i++ )) ; do
+               wait_osc_import_state client ost$((i+1)) FULL
+       done
+
+       for VALUE in $(lctl get_param osc.*osc-[^mM]*.checksum_type); do
+               PARAM=$(echo ${VALUE[0]} | cut -d "=" -f1)
+               algo=$(lctl get_param -n $PARAM | sed 's/.*\[\(.*\)\].*/\1/g')
                [ "$algo" = "adler" ] || error "algo set to $algo instead of adler"
        done
        remount_client $MOUNT
@@ -6767,60 +6674,73 @@ test_101f() {
 }
 run_test 101f "check mmap read performance"
 
+test_101g_brw_size_test() {
+       local mb=$1
+       local pages=$((mb * 1048576 / $(page_size)))
+
+       $LCTL set_param osc.*.max_pages_per_rpc=${mb}M ||
+               { error "unable to set max_pages_per_rpc=${mb}M"; return 1; }
+       for mp in $($LCTL get_param -n osc.*.max_pages_per_rpc); do
+               [ $mp -ne $pages ] && error "max_pages_per_rpc $mp != $pages" &&
+                       return 2
+       done
+
+       $LCTL set_param -n osc.*.rpc_stats=0
+
+       # 10 RPCs should be enough for the test
+       local count=10
+       dd if=/dev/zero of=$DIR/$tfile bs=${mb}M count=$count ||
+               { error "dd write ${mb} MB blocks failed"; return 3; }
+       cancel_lru_locks osc
+       dd of=/dev/null if=$DIR/$tfile bs=${mb}M count=$count ||
+               { error "dd write ${mb} MB blocks failed"; return 4; }
+
+       # calculate number of full-sized read and write RPCs
+       rpcs=($($LCTL get_param -n 'osc.*.rpc_stats' |
+               sed -n '/pages per rpc/,/^$/p' |
+               awk '/'$pages':/ { reads += $2; writes += $5 };' \
+               'END { print reads,writes }'))
+       [ ${rpcs[0]} -ne $count ] && error "${rpcs[0]} != $count read RPCs" &&
+               return 5
+       [ ${rpcs[1]} -ne $count ] && error "${rpcs[1]} != $count write RPCs" &&
+               return 6
+
+       return 0
+}
+
 test_101g() {
        local rpcs
        local osts=$(get_facets OST)
        local list=$(comma_list $(osts_nodes))
        local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       local brw_size="obdfilter.*.brw_size"
 
-       save_lustre_params $osts "obdfilter.*.brw_size" > $p
-
-       $LFS setstripe -c 1 $DIR/$tfile
+       $LFS setstripe -i 0 -c 1 $DIR/$tfile
 
+       local orig_mb=$(do_facet ost1 $LCTL get_param -n $brw_size | head -n 1)
        if [ $(lustre_version_code ost1) -ge $(version_code 2.8.52) ]; then
-               set_osd_param $list '' brw_size 16M
-
-               echo "remount client to enable large RPC size"
-               remount_client $MOUNT || error "remount_client failed"
-
-               for mp in $($LCTL get_param -n osc.*.max_pages_per_rpc); do
-                       [ "$mp" -eq 4096 ] ||
-                               error "max_pages_per_rpc not correctly set"
-               done
-
-               $LCTL set_param -n osc.*.rpc_stats=0
-
-               # 10*16 MiB should be enough for the test
-               dd if=/dev/zero of=$DIR/$tfile bs=16M count=10
-               cancel_lru_locks osc
-               dd of=/dev/null if=$DIR/$tfile bs=16M count=10
+               [ $(lustre_version_code ost1) -ge $(version_code 2.9.52) ] &&
+                       suffix="M"
+               if [[ $orig_mb < 16 ]]; then
+                       save_lustre_params $osts "$brw_size" > $p
+                       do_nodes $list $LCTL set_param -n $brw_size=16$suffix ||
+                               error "set 16MB RPC size failed"
+
+                       echo "remount client to enable new RPC size"
+                       remount_client $MOUNT || error "remount_client failed"
+               fi
 
-               # calculate 16 MiB RPCs
-               rpcs=$($LCTL get_param 'osc.*.rpc_stats' |
-                      sed -n '/pages per rpc/,/^$/p' |
-                      awk 'BEGIN { sum = 0 }; /4096:/ { sum += $2 };
-                           END { print sum }')
-               echo $rpcs RPCs
-               [ "$rpcs" -eq 10 ] || error "not all RPCs are 16 MiB BRW rpcs"
+               test_101g_brw_size_test 16 || error "16MB RPC test failed"
+               # should be able to set brw_size=12, but no rpc_stats for that
+               test_101g_brw_size_test 8 || error "8MB RPC test failed"
        fi
 
-       echo "set RPC size to 4MB"
-
-       $LCTL set_param -n osc.*.max_pages_per_rpc=4M osc.*.rpc_stats=0
-       dd if=/dev/zero of=$DIR/$tfile bs=4M count=25
-       cancel_lru_locks osc
-       dd of=/dev/null if=$DIR/$tfile bs=4M count=25
-
-       # calculate 4 MiB RPCs
-       rpcs=$($LCTL get_param 'osc.*.rpc_stats' |
-               sed -n '/pages per rpc/,/^$/p' |
-               awk 'BEGIN { sum = 0 }; /1024:/ { sum += $2 };
-                    END { print sum }')
-       echo $rpcs RPCs
-       [ "$rpcs" -eq 25 ] || error "not all RPCs are 4 MiB BRW rpcs"
+       test_101g_brw_size_test 4 || error "4MB RPC test failed"
 
-       restore_lustre_params < $p
-       remount_client $MOUNT || error "remount_client failed"
+       if [[ $orig_mb < 16 ]]; then
+               restore_lustre_params < $p
+               remount_client $MOUNT || error "remount_client restore failed"
+       fi
 
        rm -f $p $DIR/$tfile
 }
@@ -7356,7 +7276,8 @@ test_103a() {
 
        SAVE_UMASK=$(umask)
        umask 0022
-       cd $DIR
+       mkdir -p $DIR/$tdir
+       cd $DIR/$tdir
 
        echo "performing cp ..."
        run_acl_subtest cp || error "run_acl_subtest cp failed"
@@ -7635,20 +7556,24 @@ run_test 115 "verify dynamic thread creation===================="
 free_min_max () {
        wait_delete_completed
        AVAIL=($(lctl get_param -n osc.*[oO][sS][cC]-[^M]*.kbytesavail))
-       echo OST kbytes available: ${AVAIL[@]}
-       MAXI=0; MAXV=${AVAIL[0]}
-       MINI=0; MINV=${AVAIL[0]}
+       echo "OST kbytes available: ${AVAIL[@]}"
+       MAXV=${AVAIL[0]}
+       MAXI=0
+       MINV=${AVAIL[0]}
+       MINI=0
        for ((i = 0; i < ${#AVAIL[@]}; i++)); do
                #echo OST $i: ${AVAIL[i]}kb
                if [[ ${AVAIL[i]} -gt $MAXV ]]; then
-                       MAXV=${AVAIL[i]}; MAXI=$i
+                       MAXV=${AVAIL[i]}
+                       MAXI=$i
                fi
                if [[ ${AVAIL[i]} -lt $MINV ]]; then
-                       MINV=${AVAIL[i]}; MINI=$i
+                       MINV=${AVAIL[i]}
+                       MINI=$i
                fi
        done
-       echo Min free space: OST $MINI: $MINV
-       echo Max free space: OST $MAXI: $MAXV
+       echo "Min free space: OST $MINI: $MINV"
+       echo "Max free space: OST $MAXI: $MAXV"
 }
 
 test_116a() { # was previously test_116()
@@ -7671,9 +7596,9 @@ test_116a() { # was previously test_116()
 
        # Check if we need to generate uneven OSTs
        test_mkdir -p $DIR/$tdir/OST${MINI}
-       local FILL=$(($MINV / 4))
-       local DIFF=$(($MAXV - $MINV))
-       local DIFF2=$(($DIFF * 100 / $MINV))
+       local FILL=$((MINV / 4))
+       local DIFF=$((MAXV - MINV))
+       local DIFF2=$((DIFF * 100 / MINV))
 
        local threshold=$(do_facet $SINGLEMDS \
                lctl get_param -n *.*MDT0000-mdtlov.qos_threshold_rr | head -n1)
@@ -7687,15 +7612,15 @@ test_116a() { # was previously test_116()
        else
                # generate uneven OSTs. Write 2% over the QOS threshold value
                echo "no"
-               DIFF=$(($threshold - $DIFF2 + 2))
-               DIFF2=$(( ($MINV * $DIFF)/100 ))
-               echo "Fill ${DIFF}% remaining space in OST${MINI} with ${DIFF2}KB"
+               DIFF=$((threshold - DIFF2 + 2))
+               DIFF2=$((MINV * DIFF / 100))
+               echo "Fill $DIFF% remaining space in OST$MINI with ${DIFF2}KB"
                $SETSTRIPE -i $MINI -c 1 $DIR/$tdir/OST${MINI} ||
                        error "setstripe failed"
-               DIFF=$(($DIFF2 / 2048))
+               DIFF=$((DIFF2 / 2048))
                i=0
                while [ $i -lt $DIFF ]; do
-                       i=$(($i + 1))
+                       i=$((i + 1))
                        dd if=/dev/zero of=$DIR/$tdir/OST${MINI}/$tfile-$i \
                                bs=2M count=1 2>/dev/null
                        echo -n .
@@ -7706,10 +7631,10 @@ test_116a() { # was previously test_116()
                free_min_max
        fi
 
-       DIFF=$(($MAXV - $MINV))
-       DIFF2=$(($DIFF * 100 / $MINV))
-       echo -n "diff=${DIFF}=${DIFF2}% must be > ${threshold}% for QOS mode..."
-       if [[ $DIFF2 -gt $threshold ]]; then
+       DIFF=$((MAXV - MINV))
+       DIFF2=$((DIFF * 100 / MINV))
+       echo -n "diff=$DIFF=$DIFF2% must be > $threshold% for QOS mode..."
+       if [ $DIFF2 -gt $threshold ]; then
                echo "ok"
        else
                echo "failed - QOS mode won't be used"
@@ -7718,12 +7643,14 @@ test_116a() { # was previously test_116()
                return
        fi
 
-       MINI1=$MINI; MINV1=$MINV
-       MAXI1=$MAXI; MAXV1=$MAXV
+       MINI1=$MINI
+       MINV1=$MINV
+       MAXI1=$MAXI
+       MAXV1=$MAXV
 
        # now fill using QOS
        $SETSTRIPE -c 1 $DIR/$tdir
-       FILL=$(($FILL / 200))
+       FILL=$((FILL / 200))
        if [ $FILL -gt 600 ]; then
                FILL=600
        fi
@@ -7741,31 +7668,31 @@ test_116a() { # was previously test_116()
 
        echo "Note: free space may not be updated, so measurements might be off"
        free_min_max
-       DIFF2=$(($MAXV - $MINV))
+       DIFF2=$((MAXV - MINV))
        echo "free space delta: orig $DIFF final $DIFF2"
        [ $DIFF2 -gt $DIFF ] && echo "delta got worse!"
-       DIFF=$(($MINV1 - ${AVAIL[$MINI1]}))
+       DIFF=$((MINV1 - ${AVAIL[$MINI1]}))
        echo "Wrote ${DIFF}KB to smaller OST $MINI1"
-       DIFF2=$(($MAXV1 - ${AVAIL[$MAXI1]}))
+       DIFF2=$((MAXV1 - ${AVAIL[$MAXI1]}))
        echo "Wrote ${DIFF2}KB to larger OST $MAXI1"
        if [[ $DIFF -gt 0 ]]; then
-               FILL=$(($DIFF2 * 100 / $DIFF - 100))
+               FILL=$((DIFF2 * 100 / DIFF - 100))
                echo "Wrote ${FILL}% more data to larger OST $MAXI1"
        fi
 
        # Figure out which files were written where
        UUID=$(lctl get_param -n lov.${FSNAME}-clilov-*.target_obd |
-                 awk '/'$MINI1': / {print $2; exit}')
+              awk '/'$MINI1': / {print $2; exit}')
        echo $UUID
        MINC=$($GETSTRIPE --ost $UUID $DIR/$tdir | grep $DIR | wc -l)
        echo "$MINC files created on smaller OST $MINI1"
        UUID=$(lctl get_param -n lov.${FSNAME}-clilov-*.target_obd |
-                 awk '/'$MAXI1': / {print $2; exit}')
+              awk '/'$MAXI1': / {print $2; exit}')
        echo $UUID
        MAXC=$($GETSTRIPE --ost $UUID $DIR/$tdir | grep $DIR | wc -l)
        echo "$MAXC files created on larger OST $MAXI1"
        if [[ $MINC -gt 0 ]]; then
-               FILL=$(($MAXC * 100 / $MINC - 100))
+               FILL=$((MAXC * 100 / MINC - 100))
                echo "Wrote ${FILL}% more files to larger OST $MAXI1"
        fi
        [[ $MAXC -gt $MINC ]] ||
@@ -8410,6 +8337,7 @@ test_120e() {
        stat $DIR/$tdir $DIR/$tdir/f1 > /dev/null
        # XXX client can not do early lock cancel of OST lock
        # during unlink (LU-4206), so cancel osc lock now.
+       sleep 2
        cancel_lru_locks osc
        can1=$(do_facet $SINGLEMDS \
               "$LCTL get_param -n ldlm.services.ldlm_canceld.stats" |
@@ -8452,6 +8380,7 @@ test_120f() {
        stat $DIR/$tdir/d1 $DIR/$tdir/d2 $DIR/$tdir/d1/f1 $DIR/$tdir/d2/f2 > /dev/null
        # XXX client can not do early lock cancel of OST lock
        # during rename (LU-4206), so cancel osc lock now.
+       sleep 2
        cancel_lru_locks osc
        can1=$(do_facet $SINGLEMDS \
               "$LCTL get_param -n ldlm.services.ldlm_canceld.stats" |
@@ -8746,11 +8675,18 @@ test_124b() {
 
        NR=$(($(default_lru_size)*20))
        if [[ $NR -gt $LIMIT ]]; then
-                log "Limit lock number by $LIMIT locks"
-                NR=$LIMIT
-        fi
-        lru_resize_disable mdc
-        test_mkdir -p $DIR/$tdir/disable_lru_resize ||
+               log "Limit lock number by $LIMIT locks"
+               NR=$LIMIT
+       fi
+
+       IFree=$(mdsrate_inodes_available)
+       if [ $IFree -lt $NR ]; then
+               log "Limit lock number by $IFree inodes"
+               NR=$IFree
+       fi
+
+       lru_resize_disable mdc
+       test_mkdir -p $DIR/$tdir/disable_lru_resize ||
                error "failed to create $DIR/$tdir/disable_lru_resize"
 
         createmany -o $DIR/$tdir/disable_lru_resize/f $NR
@@ -11011,6 +10947,36 @@ test_160d() {
 }
 run_test 160d "verify that changelog log catch the migrate event"
 
+test_160e() {
+       # Create a user
+       CL_USER=$(do_facet $SINGLEMDS $LCTL --device $MDT0 \
+               changelog_register -n)
+       echo "Registered as changelog user $CL_USER"
+       trap cleanup_changelog EXIT
+
+       # Delete a future user (expect fail)
+       do_facet $SINGLEMDS $LCTL --device $MDT0 changelog_deregister cl77
+       local rc=$?
+
+       if [ $rc -eq 0 ]; then
+               error "Deleted non-existant user cl77"
+       elif [ $rc -ne 2 ]; then
+               error "changelog_deregister failed with $rc, " \
+                       "expected 2 (ENOENT)"
+       fi
+
+       # Clear to a bad index (1 billion should be safe)
+       $LFS changelog_clear $MDT0 $CL_USER 1000000000
+       rc=$?
+
+       if [ $rc -eq 0 ]; then
+               error "Successfully cleared to invalid CL index"
+       elif [ $rc -ne 22 ]; then
+               error "changelog_clear failed with $rc, expected 22 (EINVAL)"
+       fi
+}
+run_test 160e "changelog negative testing"
+
 test_161a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        test_mkdir -p -c1 $DIR/$tdir
@@ -11912,7 +11878,7 @@ test_200() {
                break
        done
 
-       cleanup_pools
+       destroy_test_pools
        return $rc
 }
 run_test 200 "OST pools"
@@ -12176,8 +12142,10 @@ test_205() { # Job stats
        cmd="mv -f $DIR/$tfile $DIR/$tdir.rename"
        verify_jobstats "$cmd" "$SINGLEMDS"
        # jobstats expiry - sleep until old stats should be expired
-       local left=$((interval_new + 2 - (SECONDS - start)))
-       [ $left -ge 0 ] && echo "sleep $left for expiry" && sleep $((left + 1))
+       local left=$((interval_new + 5 - (SECONDS - start)))
+       [ $left -ge 0 ] && wait_update_facet $SINGLEMDS \
+               "lctl get_param *.*.job_stats | grep -c 'job_id.*mkdir'" \
+                       "0" $left
        cmd="mkdir $DIR/$tdir.expire"
        verify_jobstats "$cmd" "$SINGLEMDS"
        [ $(do_facet $SINGLEMDS lctl get_param *.*.job_stats |
@@ -12607,7 +12575,7 @@ test_220() { #LU-325
        do_facet ost$((OSTIDX + 1)) lctl set_param fail_val=-1
        #define OBD_FAIL_OST_ENOINO              0x229
        do_facet ost$((OSTIDX + 1)) lctl set_param fail_loc=0x229
-       do_facet mgs $LCTL pool_new $FSNAME.$TESTNAME || return 1
+       create_pool $FSNAME.$TESTNAME || return 1
        do_facet mgs $LCTL pool_add $FSNAME.$TESTNAME $OST || return 2
 
        $SETSTRIPE $DIR/$tdir -i $OSTIDX -c 1 -p $FSNAME.$TESTNAME
@@ -13779,7 +13747,7 @@ test_241_dio() {
        done
 }
 
-test_241() {
+test_241a() { # was test_241
        dd if=/dev/zero of=$DIR/$tfile count=1 bs=40960
        ls -la $DIR/$tfile
        cancel_lru_locks osc
@@ -13788,7 +13756,7 @@ test_241() {
        test_241_dio 1000
        wait $PID
 }
-run_test 241 "bio vs dio"
+run_test 241a "bio vs dio"
 
 test_241b() {
        dd if=/dev/zero of=$DIR/$tfile count=1 bs=40960
@@ -14136,8 +14104,8 @@ test_253() {
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        remote_mgs_nodsh && skip "remote MGS with nodsh" && return
 
-       local ost_name=$($LFS osts | grep ${ostidx}": " | \
-               awk '{print $2}' | sed -e 's/_UUID$//')
+       local ost_name=$($LFS osts |
+               sed -n 's/^'$ostidx': \(.*\)_UUID .*/\1/p')
        # on the mdt's osc
        local mdtosc_proc1=$(get_mdtosc_proc_path $SINGLEMDS $ost_name)
        do_facet $SINGLEMDS $LCTL get_param -n \
@@ -14156,8 +14124,7 @@ test_253() {
                        osp.$mdtosc_proc1.reserved_mb_low)
        echo "prev high watermark $last_wm_h, prev low watermark $last_wm_l"
 
-       do_facet mgs $LCTL pool_new $FSNAME.$TESTNAME ||
-               error "Pool creation failed"
+       create_pool $FSNAME.$TESTNAME || error "Pool creation failed"
        do_facet mgs $LCTL pool_add $FSNAME.$TESTNAME $ost_name ||
                error "Adding $ost_name to pool failed"
 
@@ -14357,6 +14324,9 @@ ladvise_willread_performance()
 }
 
 test_255a() {
+       [ $(lustre_version_code ost1) -lt $(version_code 2.8.54) ] &&
+               skip "lustre < 2.8.54 does not support ladvise " && return
+
        lfs setstripe -c -1 -i 0 $DIR/$tfile || error "$tfile failed"
 
        ladvise_no_type willread $DIR/$tfile &&
@@ -14365,9 +14335,6 @@ test_255a() {
        ladvise_no_ioctl $DIR/$tfile &&
                skip "ladvise ioctl is not supported" && return
 
-       [ $(lustre_version_code ost1) -lt $(version_code 2.8.54) ] &&
-               skip "lustre < 2.8.54 does not support ladvise " && return
-
        local size_mb=100
        local size=$((size_mb * 1048576))
        dd if=/dev/zero of=$DIR/$tfile bs=1048576 count=$size_mb ||
@@ -14910,6 +14877,24 @@ test_300g() {
        mkdir $DIR/$tdir
        mkdir $DIR/$tdir/normal_dir
 
+       #Checking when client cache stripe index
+       $LFS setdirstripe -c$MDSCOUNT $DIR/$tdir/striped_dir
+       $LFS setdirstripe -D -i1 $DIR/$tdir/striped_dir ||
+               error "create striped_dir failed"
+
+       mkdir $DIR/$tdir/striped_dir/dir1 ||
+               error "create dir1 fails"
+       stripe_index=$($LFS getdirstripe -i $DIR/$tdir/striped_dir/dir1)
+       [ $stripe_index -eq 1 ] ||
+               error "dir1 expect 1 got $stripe_index"
+
+       $LFS setdirstripe -i2 $DIR/$tdir/striped_dir/dir2 ||
+               error "create dir2 fails"
+       stripe_index=$($LFS getdirstripe -i $DIR/$tdir/striped_dir/dir2)
+       [ $stripe_index -eq 2 ] ||
+               error "dir2 expect 2 got $stripe_index"
+
+       #check default stripe count/stripe index
        test_300_check_default_striped_dir normal_dir $MDSCOUNT 1
        test_300_check_default_striped_dir normal_dir 1 0
        test_300_check_default_striped_dir normal_dir 2 1
@@ -15352,12 +15337,14 @@ test_311() {
        local new_iused
        for i in $(seq 120); do
                new_iused=$($LFS df -i | grep OST0000 | awk '{ print $3 }')
-               [ $((old_iused - new_iused)) -gt 800 ] && break
+               # system may be too busy to destroy all objs in time, use
+               # a somewhat small value to not fail autotest
+               [ $((old_iused - new_iused)) -gt 400 ] && break
                sleep 1
        done
 
        echo "waited $i sec, old Iused $old_iused, new Iused $new_iused"
-       [ $((old_iused - new_iused)) -gt 800 ] ||
+       [ $((old_iused - new_iused)) -gt 400 ] ||
                error "objs not destroyed after unlink"
 }
 run_test 311 "disable OSP precreate, and unlink should destroy objs"
@@ -15460,7 +15447,30 @@ test_312() { # LU-4856
 }
 run_test 312 "make sure ZFS adjusts its block size by write pattern"
 
-test_399() { # LU-7655 for OST fake write
+test_313() {
+       local file=$DIR/$tfile
+       rm -f $file
+       $SETSTRIPE -c 1 -i 0 $file || error "setstripe failed"
+
+       # define OBD_FAIL_TGT_RCVD_EIO           0x720
+       do_facet ost1 "$LCTL set_param fail_loc=0x720"
+       dd if=/dev/zero of=$file bs=4096 oflag=direct count=1 &&
+               error "write should failed"
+       do_facet ost1 "$LCTL set_param fail_loc=0"
+       rm -f $file
+}
+run_test 313 "io should fail after last_rcvd update fail"
+
+test_fake_rw() {
+       local read_write=$1
+       if [ "$read_write" = "write" ]; then
+               local dd_cmd="dd if=/dev/zero of=$DIR/$tfile"
+       elif [ "$read_write" = "read" ]; then
+               local dd_cmd="dd of=/dev/null if=$DIR/$tfile"
+       else
+               error "argument error"
+       fi
+
        # turn off debug for performance testing
        local saved_debug=$($LCTL get_param -n debug)
        $LCTL set_param debug=0
@@ -15472,35 +15482,56 @@ test_399() { # LU-7655 for OST fake write
        local blocks=$((ost1_avail_size/2/1024)) # half avail space by megabytes
        [ $blocks -gt 1000 ] && blocks=1000 # 1G in maximum
 
+       if [ "$read_write" = "read" ]; then
+               truncate -s $(expr 1048576 \* $blocks) $DIR/$tfile
+       fi
+
        local start_time=$(date +%s.%N)
-       dd if=/dev/zero of=$DIR/$tfile bs=1M count=$blocks oflag=sync ||
-               error "real dd writing error"
+       $dd_cmd bs=1M count=$blocks oflag=sync ||
+               error "real dd $read_write error"
        local duration=$(bc <<< "$(date +%s.%N) - $start_time")
-       rm -f $DIR/$tfile
 
-       # define OBD_FAIL_OST_FAKE_WRITE        0x238
+       if [ "$read_write" = "write" ]; then
+               rm -f $DIR/$tfile
+       fi
+
+       # define OBD_FAIL_OST_FAKE_RW           0x238
        do_facet ost1 $LCTL set_param fail_loc=0x238
 
        local start_time=$(date +%s.%N)
-       dd if=/dev/zero of=$DIR/$tfile bs=1M count=$blocks oflag=sync ||
-               error "fake dd writing error"
+       $dd_cmd bs=1M count=$blocks oflag=sync ||
+               error "fake dd $read_write error"
        local duration_fake=$(bc <<< "$(date +%s.%N) - $start_time")
 
-       # verify file size
-       cancel_lru_locks osc
-       $CHECKSTAT -t file -s $((blocks * 1024 * 1024)) $DIR/$tfile ||
-               error "$tfile size not $blocks MB"
-
+       if [ "$read_write" = "write" ]; then
+               # verify file size
+               cancel_lru_locks osc
+               $CHECKSTAT -t file -s $((blocks * 1024 * 1024)) $DIR/$tfile ||
+                       error "$tfile size not $blocks MB"
+       fi
        do_facet ost1 $LCTL set_param fail_loc=0
 
-       echo "fake write $duration_fake vs. normal write $duration in seconds"
+       echo "fake $read_write $duration_fake vs. normal $read_write" \
+               "$duration in seconds"
        [ $(bc <<< "$duration_fake < $duration") -eq 1 ] ||
                error_not_in_vm "fake write is slower"
 
        $LCTL set_param -n debug="$saved_debug"
        rm -f $DIR/$tfile
 }
-run_test 399 "fake write should not be slower than normal write"
+test_399a() { # LU-7655 for OST fake write
+       test_fake_rw write
+}
+run_test 399a "fake write should not be slower than normal write"
+
+
+test_399b() { # LU-8726 for OST fake read
+       if [ "$(facet_fstype ost1)" != "ldiskfs" ]; then
+               skip "only for ldiskfs" && return 0
+       fi
+       test_fake_rw read
+}
+run_test 399b "fake read should not be slower than normal read"
 
 test_400a() { # LU-1606, was conf-sanity test_74
        local extra_flags=''
@@ -15654,6 +15685,14 @@ test_401d() {
 run_test 401d "Verify 'lctl set_param' accepts values containing '='"
 
 test_402() {
+       local server_version=$(lustre_version_code $SINGLEMDS)
+       [[ $server_version -ge $(version_code 2.7.66) ]] ||
+       [[ $server_version -ge $(version_code 2.7.18.4) &&
+               $server_version -lt $(version_code 2.7.50) ]] ||
+       [[ $server_version -ge $(version_code 2.7.2) &&
+               $server_version -lt $(version_code 2.7.11) ]] ||
+               { skip "Need MDS version 2.7.2+ or 2.7.18.4+ or 2.7.66+";
+                       return; }
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        $LFS setdirstripe -i 0 $DIR/$tdir || error "setdirstripe -i 0 failed"
 #define OBD_FAIL_MDS_FLD_LOOKUP 0x15c
@@ -15852,6 +15891,38 @@ test_408() {
 }
 run_test 408 "drop_caches should not hang due to page leaks"
 
+test_409()
+{
+       [ $MDSCOUNT -lt 2 ] &&
+               skip "We need at least 2 MDTs for this test" && return
+
+       check_mount_and_prep
+
+       mkdir -p $DIR/$tdir || error "(0) Fail to mkdir"
+       $LFS mkdir -i 1 -c 2 $DIR/$tdir/foo || error "(1) Fail to mkdir"
+       touch $DIR/$tdir/guard || error "(2) Fail to create"
+
+       local PREFIX=$(str_repeat 'A' 128)
+       echo "Create 1K hard links start at $(date)"
+       createmany -l $DIR/$tdir/guard $DIR/$tdir/foo/${PREFIX}_ 1000 ||
+               error "(3) Fail to hard link"
+
+       echo "Links count should be right although linkEA overflow"
+       stat $DIR/$tdir/guard || error "(4) Fail to stat"
+       local linkcount=$(stat --format=%h $DIR/$tdir/guard)
+       [ $linkcount -eq 1001 ] ||
+               error "(5) Unexpected hard links count: $linkcount"
+
+       echo "List all links start at $(date)"
+       ls -l $DIR/$tdir/foo > /dev/null ||
+               error "(6) Fail to list $DIR/$tdir/foo"
+
+       echo "Unlink hard links start at $(date)"
+       unlinkmany $DIR/$tdir/foo/${PREFIX}_ 1000 ||
+               error "(7) Fail to unlink"
+}
+run_test 409 "Large amount of cross-MDTs hard links on the same file"
+
 #
 # tests that do cleanup/setup should be run at the end
 #